/* net server test
 * Compile: cc -o nets -lsocket -lnsl nets.c
 * Usage: nets [<port number>]
 *
 * DJA, PRESTO/SST, 28 fevrier 97
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/un.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/uio.h>
#include <fcntl.h>
extern int errno;
#include <errno.h>
 
/* for solaris */ 
#include <stropts.h>
#include <sys/conf.h>

void do_accept(int sock) {
  struct sockaddr_in sockaddr;
  int len = sizeof sockaddr;

  FILE *filePtr;
  int fd, fd1;
  int addr, f1, f2, f3, f4;
  char tmp[128];
  int size;
  char *foo;
  int recvcnt;

  foo = (char *)malloc(256);

  while(1) {
    fd = accept(sock,(struct sockaddr *)&sockaddr, &len);
    if (fd<0) { 
      printf("Failed accept, errno is %d.\n",fd);
      close(sock);
      exit(1);
    }
    printf("Accepted connection.\n");
    fflush(stdout);
    recvcnt = recv(fd,foo,256,0);
    if (recvcnt<0) { 
      printf("recv failed with errno %d\n",errno);
    } else {
      printf("Received %d bytes from client: %s.\n",recvcnt,foo);
    }
  }
}

main(int argc,char **argv) {
  int sock,status,result;
  struct sockaddr_in sockaddr;
  char *host;
  char localhost[MAXHOSTNAMELEN];
  struct hostent *hostent, _hostent;
  int hostaddr, hostaddrPtr[2];
  int port=2030;

  if (argc>1) { port = atoi(argv[1]); }
  printf("Will accept connections on port %d\n", port);

  gethostname(localhost, MAXHOSTNAMELEN);
  host=localhost;
  hostent = gethostbyname(host);

  if (hostent == NULL) {
    if (strlen(host) == 0) {
      memset(&hostaddr, 0, sizeof(hostaddr));
    } else {
      hostaddr = inet_addr(host);
      if (hostaddr == -1) {
	return -1;
      }
    }
    _hostent.h_addr_list = (char **) hostaddrPtr;
    _hostent.h_addr_list[0] = (char *) &hostaddr;
    _hostent.h_length = sizeof(hostaddr);
    _hostent.h_addr_list[1] = NULL;
    _hostent.h_addrtype = AF_INET;
    hostent = &_hostent;
  }

  sock = socket(PF_INET, SOCK_STREAM, 0);
  if (sock<0) { printf("Cannot create socket.\n"); exit(1); }
  memset((char *) &sockaddr, 0, sizeof(sockaddr));
  sockaddr.sin_family = AF_INET;
  memcpy((char *) &(sockaddr.sin_addr.s_addr),
	 (char *) hostent->h_addr_list[0],
	 (size_t) hostent->h_length);
  sockaddr.sin_port = htons(port);
  status = bind(sock, (struct sockaddr *)&sockaddr, sizeof(sockaddr));
  if (status < 0) {
    close(sock);
    printf("Failed to bind socket: %d\n",status);
    exit(1);
  }
  listen(sock,5);

  do_accept(sock);
}
